import _extends from "@babel/runtime/helpers/esm/extends";
import { concatMap, delay, map, of, take } from "rxjs";
export class MockServer {
  constructor(config) {
    this.config = config;
  }

  getConfig() {
    const sum = this.config.responses.reduce((t, e) => t + e.ocurrence, 0);
    const ranges = this.config.responses.map(resp => {
      return _extends({}, resp, {
        percentil: Math.floor(resp.ocurrence * 100 / sum)
      });
    }).reduce((t, e) => {
      const lastRange = t.length > 0 ? t[t.length - 1] : {
        top: 0,
        bottom: 0
      };
      return [...t, _extends({}, e, {
        top: lastRange.top + e.percentil,
        bottom: lastRange.top
      })];
    }, []);
    const randomValue = Math.floor(Math.random() * 100);
    return ranges.find(range => randomValue > range.bottom && randomValue <= range.top);
  }

  invoke() {
    return of("").pipe(concatMap(_ => of(this.getConfig())), take(1), delay(this.config.time || Math.random() * 3000), map(config => {
      const data = config.data();
      if (config.isError) throw data;
      return data;
    }));
  }

}

MockServer.create = config => {
  return new MockServer(config);
};