"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.ControlErrors = void 0;

var _react = _interopRequireDefault(require("react"));

var _rxjs = require("rxjs");

var _ = require("../../..");

const ControlErrors = props => {
  const {
    value
  } = (0, _.useObservableSubscribe)({
    obs$: props.control.statusChanges.pipe((0, _rxjs.startWith)(props.control.status), (0, _rxjs.map)(statusType => {
      if (statusType === "INVALID") {
        return {
          status: "ERROR",
          error: props.control.errors
        };
      } else if (statusType === "PENDING") {
        return {
          status: "PROCESSING",
          data: {}
        };
      }

      return {
        status: "SUCCESS",
        data: {}
      };
    }))
  });
  const renderErrors = props.renderErrors;
  const errorTemplate = value.status === "ERROR" && renderErrors && renderErrors({
    errors: value.error,
    control: props.control
  });
  const renderProcessing = props.renderProcessing;
  const processingTemplate = value.status === "PROCESSING" && renderProcessing && renderProcessing();
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, errorTemplate, processingTemplate);
};

exports.ControlErrors = ControlErrors;