"use strict";

exports.__esModule = true;
exports.useFormGroup = void 0;

var _react = require("react");

var _rxjs = require("rxjs");

var _model = require("../../../model");

const useFormGroup = formGroup => {
  const [, state] = (0, _react.useState)({});
  const [, reRender] = (0, _react.useState)(0);
  const formGroupRef = (0, _react.useRef)(formGroup || new _model.FormGroup({}));
  const setFormGroup$ = new _rxjs.Subject();
  const destroy$ = new _rxjs.Subject();
  (0, _react.useEffect)(() => {
    setFormGroup$.pipe((0, _rxjs.takeUntil)(destroy$), (0, _rxjs.filter)(formGroup => formGroup !== formGroupRef.current), (0, _rxjs.tap)(formGroup => {
      setImmediate(() => {
        formGroupRef.current = formGroup;
        formGroupRef.current.dispatchStateFn = state;
      });
    }), (0, _rxjs.delay)(1), (0, _rxjs.tap)(() => {
      reRender(Math.random());
    })).subscribe();
  }, []);

  const getFormGroup = () => {
    return formGroupRef.current;
  };

  return {
    formGroup: formGroupRef.current,
    setFormGroup: setFormGroup$.next.bind(setFormGroup$),
    getFormGroup: getFormGroup.bind(formGroupRef)
  };
};

exports.useFormGroup = useFormGroup;